insert into macroheader values ('SQL UPDATE_DAY_TBL','Insert updated data into Day Tbl',0,0,1);
insert into macrodetail values ('SQL UPDATE_DAY_TBL',1,37,'',NULL,'Called by Timed Event, this updates the temp data every 10 minutes for the Day chart.',0,'','The Table runs from 1-24 hours with 6 bins/hour');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',2,15,'[LOCAL1]',NULL,'now()',0,'','Time sample is taken');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',3,15,'[LOCAL2]',NULL,'left("[LOCAL1]",2)',0,'','Get hours');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',4,15,'[LOCAL3]',NULL,'mid("[LOCAL1]",4,2)',0,'','Get minutes');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',5,37,'',NULL,'The following formula coverts the current sample "minutes" time into a standardized bin, as there are specific bin labels in the SQL Table that must be matched exactly in order to access the Table.

The formula for this specific macro (where LOCAL3 holds the current minutes portion of the time) would be...

   round([LOCAL3]/10,0)/6

Thus for this  macro where data is sampled every 10 minutes, forming 6 bins, any time (for example) between 5 and 14.9 is rounded to 10, which is bin "1" of the 6 bins (0-5).
',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',6,37,'',NULL,'To compute a bin in general, divide the current minute time by the sample period (10 minutes) and then round the result to its Integer value. (eg, a sample from the 13 minute point divided by 10 = 1.3 which rounds to "1").  This results in a value in the range between 0-6.  But 6 is the same as 0, just into the next bin slot.

Then to find the bin number out of 6, divide the integer bin number by the number of bins (6 in this case) resulting in a specific bin of one of the following (0, .17, .33, .50, .67, .83, 1.0)

If the "minutes" result is 1.0, then it must be corrected back to bin 0 and the hours digit incremented.

All this is necessary because in order to graph the data on a time line, the time must be converted from a "time" format (12:30:00) into a number format (12.5) for the x-axis.',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',7,15,'[LOCAL4]',NULL,'round([LOCAL3]/10,0)/6',0,'','Locate correct bin of 6 within an hour.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',8,38,'',0,'if([LOCAL4]=1, ph_addtovar(1,2,1) + ph_setvar_a(1,4,0), [LOCAL4])',0,'','If L4=1 (bin 6) then increment hour and reset minute bin to 0.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',9,38,'',0,'if(ph_getvar_n(1,2)=24, ph_setvar_a(1,2,0), [LOCAL2])',0,'','If hours just got bumped to 24 reset it to 0.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',10,15,'[LOCAL5]',NULL,'string([LOCAL2]+[LOCAL4],"00.00")',0,'','Add together to form numeric time value.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',11,27,'',NULL,'if([LOCAL5]=0, "nextline", "GO ON")',0,'','EOD? Did we just hit the midnight bin? If so, make all data historic.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',12,36,'',NULL,'"Midnight, so make all data points historic."',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',13,38,'',0,'ph_directsql("update userdata2 SET valstring3 = valstring2  WHERE type=1")',0,'','Copy all data from the left to the right device data column to make it old ("historic") data');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',14,38,'',0,'ph_directsql("UPDATE userdata2 SET valstring2 = Null WHERE type=1")',0,'','Now clear all data from the left column so new ("Current" data can be put there.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',15,26,'',NULL,'GO ON',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',16,37,'',NULL,'******* userdata2 schema *******
uid/type/idstring/idnum/iddate/valstring1/valstring2/valstring3/valstring4/ valnum1/valnum2/valnum3/valnum4/valdate1/valdate2/valdate3/valdate4/lastchange
',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',17,37,'',NULL,'uid=seq#, type=1 {d/w/m}, idstring=dvc, valstring1=time#, valstring1=new temp, valstring2=old temp, valmun1=FRZR Avg, valnum2=FRIG Avg',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',18,37,'',NULL,'******** Insert the New Data Values ********',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',19,15,'[TEMP1]',NULL,'string({STAT-DWN-TEMP}, "00.0")',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',20,15,'[TEMP2]',NULL,'string({STAT-MID-TEMP}, "00.0")',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',21,38,'',0,'ph_directsql("update userdata2
SET valstring2 =''[TEMP1]'', valstring3=Null 
WHERE type = 1 and idstring = ''Dwn'' and valstring1=[LOCAL5]")',0,'','Write new data and erase old history for this time in order to make dashed line start after this time slot.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',22,38,'',0,'ph_directsql("update userdata2
SET valstring2 = ''[TEMP2]'', valstring3=Null 
WHERE type = 1 and idstring = ''Mid'' and valstring1=[LOCAL5]")',0,'','Write new data and erase old history for this time in order to make dashed line start after this time slot.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',23,38,'',0,'ph_directsql("update userdata2
SET valstring2 = {TEMP-OUT}, valstring3=Null  
WHERE type = 1 and idstring = ''Out'' and valstring1=[LOCAL5]")',0,'','Write new data and erase old history for this time in order to make dashed line start after this time slot.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',24,38,'',0,'ph_directsql("update userdata2
SET valstring2 = {TEMP-FRZR}, valstring3=Null 
WHERE type = 1 and idstring = ''Frzr'' and valstring1=[LOCAL5]")',0,'','Write new data and erase old history for this time in order to make dashed line start after this time slot.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',25,38,'',0,'ph_directsql("update userdata2
SET valstring2 = {TEMP-FRIG}, valstring3=Null 
WHERE type = 1 and idstring = ''Frig'' and valstring1=[LOCAL5]")',0,'','Write new data and erase old history for this time in order to make dashed line start after this time slot.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',26,37,'',NULL,'******* Calc a running Average Temp *******',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',27,15,'[LOCAL6]',NULL,'48',0,'','Num of periods to integrate over to form AVG');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',28,10,'TEMP-FRIG-AVG',NULL,'string({TEMP-FRIG-AVG}-{TEMP-FRIG-AVG}/[LOCAL6]+{TEMP-FRIG}/[LOCAL6],"0.0")',0,'','Form rolling FRIG average temp');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',29,10,'TEMP-FRZR-AVG',NULL,'string( {TEMP-FRZR-AVG} - {TEMP-FRZR-AVG}/[LOCAL6] + {TEMP-FRZR}/[LOCAL6],"0.0")',0,'','Form rolling FRZR average temp');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',30,37,'',NULL,'******* Write CSV File update *******',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',31,15,'[LOCAL8]',NULL,'"select valstring2 from userdata2 where type = 1 and idstring ="',0,'','Needed because otherwise the write file Formula below will exceed the alloted char count in the formula field.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',32,15,'[LOCAL9]',NULL,'"select valstring3 from userdata2 where type = 1 and idstring ="',0,'','Ditto');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',33,38,'',0,'ph_writefile("C:\powerhome\web\tempsDAY.csv",1,
"Time,Dwn,Dwn,Mid,Mid,Out,Out,Frzr,Frzr,Frig,Frig~r~n" + 
ph_sql(0,"SELECT valstring1 || '','' || 
([LOCAL8] ''Dwn'' and valstring1 = base.valstring1) || '','' || 
([LOCAL9] ''Dwn'' and valstring1 = base.valstring1) || '','' || 
([LOCAL8] ''Mid'' and valstring1 = base.valstring1) || '','' ||
([LOCAL9] ''Mid'' and valstring1 = base.valstring1) || '','' ||
([LOCAL8] ''Out'' and valstring1 = base.valstring1) || '','' ||  
([LOCAL9] ''Out'' and valstring1 = base.valstring1) || '','' ||  
([LOCAL8] ''Frzr'' and valstring1 = base.valstring1) || '','' ||  
([LOCAL9] ''Frzr'' and valstring1 = base.valstring1) || '','' ||  
([LOCAL8] ''Frig'' and valstring1 = base.valstring1) || '','' || 
([LOCAL9] ''Frig'' and valstring1 = base.valstring1)
from (select valstring1 from userdata2
where type = 1 and idstring = ''Dwn'')  base"))',0,'','SQL formula to extract the entire contents of the SQL Table and write a CSV file for the Chart maker.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',34,37,'',NULL,'******* Finally check frezer/refridgerator for in-tolerance performance, and outside temperatures to calibrate inside humidity settings *******

It also calls the "GET-WTHR STATS" macro.',0,'','Also checks to see if BED HEAT should be applied, and THEATER Curtains opened/closed.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',35,26,'',NULL,'FRZR CHECK',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',36,27,'',NULL,'if({ALERT_FREEZER}=1 and ({TEMP-FRZR-AVG}< -5 or {TEMP-FRZR-AVG}>8),"nextline","FRIG CHECK")
/* Send temp out of range Alert*/',0,'','Warn if Freezer <-5 or >8 degrees');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',37,36,'',NULL,'"Freezer Temp out of range at {TEMP-FRZR-AVG} degrees."',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',38,38,'',1,'ph_sendsmtpemail("smtp.gmail.com",465,"kenburkhalter@gmail.com,kenburkhalter,11!Qazwsx", "7346043585@cingularme.com","Temp Alert","Freezer Temp out of range at {TEMP-FRZR-AVG} degrees.")',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',39,10,'ALERT_FREEZER',NULL,'0',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',40,37,'',NULL,'',1,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',41,26,'',NULL,'FRIG CHECK',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',42,27,'',NULL,'if({ALERT_REFRIG}=1 and ({TEMP-FRIG-AVG}< 33 or {TEMP-FRIG-AVG}>43),"nextline","FINAL CHECKS")
/* Send temp out of range Alert*/',0,'','Warn if Fridge <32 or >43 degrees');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',43,36,'',NULL,'"Refrigerator Temp out of range at {TEMP-FRIG-AVG} degrees."',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',44,38,'',1,'ph_sendsmtpemail("smtp.gmail.com",465,"kenburkhalter@gmail.com,kenburkhalter,11!Qazwsx", "7346043585@cingularme.com","Temp Alert","Refrigerator Temp out of range at {TEMP-FRIG-AVG} degrees.")',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',45,10,'ALERT_REFRIG',NULL,'0',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',46,37,'',NULL,'',1,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',47,26,'',NULL,'FINAL CHECKS',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',48,10,'HUMIDITY_TARGET',NULL,'round(20+ {TEMP-OUT}/2,0)',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',49,10,'HUMIDITY_TARGET',NULL,'if({HUMIDITY_TARGET}<20,20,{HUMIDITY_TARGET})',0,'','');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',50,38,'',1,'if((NOW() > 20:30:00 or NOW() < 06:30:00) and {HOME-YESTERDAY}=1, ph_macro("BED_HEAT_CHK"),0)
/* Only check Bed Heat needs if its sleep time and we are Home */',0,'','Check bed heater requirements to track with outside temp.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',51,38,'',1,'if({DARK}=1 and NOW() > RELATIVETIME(00:00:00, [SUNSET]-1.0*3600) and {TEMP-OUT}<65 and {HOME}=1 and ph_getinsteonlevel("DWN PLANT")=0 ,ph_irdesc("DRAPERIES","2")+ph_irdesc("DRAPERIES","CLOSE"),0)',0,'','Check to see if Theater Curtain should be closed.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',52,38,'',1,'if(Now()>23:00:00 or Now()<6:00:00 and {TEMP-OUT}>60 ,ph_irdesc("DRAPERIES","2")+ph_irdesc("DRAPERIES","OPEN"),0)',0,'','Also check to see if it is warm enough at night to open curtains.');
insert into macrodetail values ('SQL UPDATE_DAY_TBL',53,39,'',NULL,'',0,'','');
